##Various 'mcmc' types moves
if(0) {
  mvtype = "spec_c_mean_forced"; #    "c_mean_forced"     "spec_c_mean_forced"      "c_var_forced"
  up     = T
  col    = 1
  cl     = 1
  uprand = 0.5;
  shift  = 0.0005;
  forcemv = list(mvtype, up, col, cl, shift, uprand)
  names(forcemv) = list("mvtype", "up", "col", "cl", "shift", "uprand")
  sa   = T
  test = update_params(objects=objects, iter=objects$flags$iter, gridding=T, sa=sa, forcemv = forcemv)
}

#change cluster means - this move changes them all at once
c_clust_mean_force=function(forcemv, pars, violence = 0.001)
{
     cat("   In forced c_clust_means. old parameters:\n")
     cat("   smallest" , pars$smc, "\n")
     cat("   distances", pars$cld, "\n")

   shift = forcemv$shift * (-1)^(!forcemv$up)
   pars$smc = pars$smc+shift
   pars$cld = pars$cld+shift

     cat("   In forced c_clust_means. new parameters:\n")
     cat("   smallest" , pars$smc, "\n")
     cat("   distances", pars$cld, "\n")
   return(pars)
}

#change COLLECTION SPECIFIC cluster means - this move shifts one collections clusters left or right
c_clust_mean_cspec_force=function(forcemv, pars, col_sp_var = 0.001)
{
   cat("   In forced c_clust_means_cspec. old parameters:\n")
   cat("   smallest" , pars$smc, "\n")
   cat("   distances", pars$cld, "\n")

   col =  forcemv$col
   #cl =  forcemv$cl
   shift = forcemv$shift * (-1)^(!forcemv$up)
   pars$smc[col]  = pars$smc[col] +shift
   pars$cld[col,] = pars$cld[col,]+shift

   cat("   In forced c_clust_means_cspec. new parameters:\n")
   cat("   smallest" , pars$smc, "\n")
   cat("   distances", pars$cld, "\n")
   return(pars)
}

#change cluster variances
c_clust_vars_force=function(forcemv, pars, violence = 0.001, col_sp_var = 0.0001)
{
     cat("   In forced c_clust_VARS. old parameters:\n")
     cat("   smallest" , pars$smc, "\n")
     cat("   distances", pars$cld, "\n")

   shift = forcemv$shift * (-1)^(!forcemv$up)
   pars$clv = pars$clv+shift

     cat("   In forced c_clust_VARS. new parameters:\n")
     cat("   smallest" , pars$smc, "\n")
     cat("   distances", pars$cld, "\n")
   return(pars)
}

c_hpr_clv_base_force=function(forcemv, objects, violence = 0.001, col_sp_var = 0.0001)
{
  objects$npriors$hprclv$base$mean = rnorm(    1, objects$npriors$hprclv$base_mean$mean        , sqrt(objects$npriors$hprclv$base_mean$var)   )
  objects$npriors$hprclv$base$var  = rinvgamma(1, scale = objects$npriors$hprclv$base_var$scale, shape = objects$npriors$hprclv$base_var$shape)
  base_classes              = rnorm(noco, objects$npriors$hprclv$base$mean        , sqrt(objects$npriors$hprclv$base$var))

  #This is all non-necessary code for generating variances from the prior in the absence of data - probably a total waste of time!!
  #inc_mean                  = rgamma(1, scale=objects$npriors$hprclv$inc_mean$scale, shape=objects$npriors$hprclv$inc_mean$shape)
  #inc_var                   = rgamma(1, scale=objects$npriors$hprclv$inc_var$scale , shape=objects$npriors$hprclv$inc_var$shape)
  #objects$npriors$hprclv$inc$scale = inc_var /inc_mean
  #objects$npriors$hprclv$inc$shape = inc_mean/objects$npriors$hprclv$inc$scale
  #objects$opars$clv[,1]     = exp(base_classes)
  #increment = rgamma((noco)*(nocl-1), scale=objects$npriors$hprclv$inc$scale , shape=objects$npriors$hprclv$inc$shape)
  #increment = matrix(increment, noco, (nocl-1))
  #increment = t(t(increment)*(1:(nocl-1)))
  #objects$opars$clv[,-c(1)] = exp(base_classes + increment)
  return(objects)
}


c_hpr_clv_inc_force=function(forcemv, objects, violence = 0.001, col_sp_var = 0.0001)
{
  mean = rgamma(1, scale = objects$npriors$hprclv$inc_mean$scale, shape = objects$npriors$hprclv$inc_mean$shape)
  var  = rgamma(1, scale = objects$npriors$hprclv$inc_var$scale , shape = objects$npriors$hprclv$inc_var$shape )
  objects$npriors$hprclv$inc$scale = var / mean
  objects$npriors$hprclv$inc$shape = mean/ objects$npriors$hprclv$scale
  return(objects)
}

c_hpr_smc_force=function(forcemv, objects, violence = 0.001, col_sp_var = 0.0001)
{
  objects$npriors$prsmc$mean = rnorm(    1, mean  = objects$npriors$hprsmc$mean$mean, sd    = sqrt(objects$npriors$hprsmc$mean$var))
  objects$npriors$prsmc$var  = rinvgamma(1, scale = objects$npriors$hprsmc$var$scale, shape = objects$npriors$hprsmc$var$shape     )
  return(objects)
}

c_hpr_cld_force=function(forcemv, objects, violence = 0.001, col_sp_var = 0.0001)
{
  mean = rgamma(1, scale = objects$npriors$hprcld$mean$scale, shape = objects$npriors$hprcld$mean$shape)
  var  = rgamma(1, scale = objects$npriors$hprcld$var$scale , shape = objects$npriors$hprcld$var$shape )
  objects$npriors$hprcld$scale = var / mean
  objects$npriors$hprcld$shape = mean/ objects$npriors$hprcld$scale
  return(objects)
}

# Do I want to do these stochastically or R-B this bit?
c_allele_frequencies_force=function(forcemv)
{

}

#This function will hopefully reset the allele-frequencies to the MLE/posterior mode (haven't decided yet)
max_gnf_force=function(forcemv, objects)
{
   noco = objects$opars$noco
   nocl = objects$opars$nocl
   gnf  = matrix(-1, nrow=nocl, ncol=noco)
   colnames(gnf) = colnames(objects$dat)
   rownames(gnf) = dimnames(objects$oinferred$pagd)[[2]]
   for(col in 1:noco)
   {
     for(cl in 1:nocl)
     {
       gnf[cl,col] = sum(objects$oinferred$pagd[,cl,col]*objects$dat[,col])
     }
   }
   objects$npars$gnfp$gnf = gnf
   if(DEBUG>0.9 & min(gnf)<1) {cat("Warning! Some Allele Frequencies very low. May be strong local maximum problems here.\n"); browser();}
   return(objects)
}


#change betas
c_betas_force=function(forcemv, pars, violence = 0.001)
{
   rand = runif(1, 0, 1)
   if(rand < 0.2) {beta0 = pars$betas[1] + rnorm(1, 0, violence); beta1 = pars$betas[2];}
   if(rand>= 0.2) {beta1 = pars$betas[2] + rnorm(1, 0, violence); beta0 = pars$betas[1];}
   pars$betas = c(beta0, beta1)
   return(pars)
}




