##Various 'mcmc' types moves

##PROBLEM with current system
## 1) Moves here are made without the minimum cld, clvs added on. (So clds here are just extra_cld where the true means are: min_cld + extra_cld)
## 2) This means that when cumsum(smc, cld) is all within the data range the move will be passed, however 
## 3) cumsum(smc, cld+min_cld) may be outside the data range!

#change cluster means - this move changes them all at once
c_clust_mean=function(objects, pars, violence = 0.001)
{
   reject=T; #The purpose of this variable is just to reject various moves which are stupid for various reasons.
   move_attempts = 0;
   noco          = objects$opars$noco
   nocl          = objects$opars$nocl
   grid_vals = as.numeric(rownames(objects$dat))
   violence      = violence/(2*nocl)
  #if(objects$flags$iter==34 & objects$flags$cnv_index==1501 & objects$flags$stpt_ind == 6){ debug(update_params); cat("New = "); print(objects$npars$hkclm); browser()}
   check_clm(objects=objects, smcs=pars$smc, dsts=pars$cld, move="c_clust_mean1", cur=T)
   display_attempts(DEBUG=objects$flags$DEBUG, move_attempts=move_attempts, func="c_clust_mean", pars=pars)
   while(reject)
   {
     avg_smc   = mean(pars$smc)
     avg_cld   = colMeans(pars$cld)  
     smc_diffs = pars$smc - avg_smc
     new_smc   = avg_smc   + rnorm(1, 0, violence)
     cld_diffs = pars$cld - matrix(avg_cld, nrow=nrow(pars$cld), ncol=ncol(pars$cld), byrow=T)
     new_dst   = abs(avg_cld + rnorm(pars$nocl-1, 0, violence))
     if(pars$nocl>3 & move_attempts > 200 & move_attempts < 800) { 
       #This is a hacky way of trying to 'shrink' the classes to fit the tests
       new_smc = new_smc * 0.95
       new_dst = new_dst * 0.95
     }
     #Code to reject stupid moves.
     if(objects$flags$DEBUG>0.1 & move_attempts == 200) {
       cat("Warning - seemingly difficult to find a non-stupid move in c_clust_mean.\n"); if(objects$flags$DEBUG>2 & move_attempts==200) {browser()}
       violence = violence/5
     }
     if(move_attempts>600) {
       cat("Given up - returning unchanged values after 600 attempts.\n"); if(objects$flags$DEBUG>1.5 & move_attempts==200) {browser()}
       return(pars)
     }
     new_dsts = matrix(rep(new_dst, (noco)), nrow=noco, byrow=T)  
     new_dsts = abs(new_dsts + cld_diffs)
     new_clds = mypmax(inmat = new_dsts, objects$flags$min_extra_cld)
     new_smcs =      new_smc + smc_diffs
     clm      =  make_clm(smcs=new_smcs, clds=new_dsts, noco=noco, nocl=nocl)
     reject   = check_clm(objects=objects, smcs=new_smcs, dsts=new_dsts, move="c_clust_mean1", cur=F, average=F)
     move_attempts = move_attempts+1;
   }
  #for(coll in 1:noco)
  #  clm[coll,] = rev_hk2(mom_type="mean", moments=clm[coll,], nocl=nocl, vals=grid_vals, flags=objects$flags)
   smcs_clds = make_smcs_clds(clm=clm, nocl=nocl)

   pars$smc = smcs_clds$smcs
   pars$cld = smcs_clds$clds
   display_attempts(DEBUG=objects$flags$DEBUG, move_attempts=move_attempts, func="c_clust_mean", pars=pars)
   return(pars)
}

#change cluster means - this move just moves one of the cluster centre DISTANCES (so multiple cluster centres may well change)
c_clust_mean2=function(objects, pars, violence = 0.001, combined=F)
{
   reject=T; #The purpose of this variable is just to reject various moves which are stupid for various reasons.
   move_attempts = 0;
   grid_vals = as.numeric(rownames(objects$dat))
   check_clm(objects=objects, smcs=pars$smc, dsts=pars$cld, move="c_clust_mean2", cur=T)
   display_attempts(DEBUG=objects$flags$DEBUG, move_attempts=move_attempts, func="c_clust_mean2", pars=pars)
   while(reject)
   {
     rand = runif(1, 0, 1)
     no_moves = pars$nocl
     chosen_move=F
     new_smcs  = pars$smc
     new_dsts  = pars$cld
     avg_smc   = mean(pars$smc)
     if(length(pars$cld)>0) avg_cld = colMeans(pars$cld) else avg_cld = numeric(0);
     new_smc = avg_smc
     new_dst = avg_cld
     if(rand<1/no_moves)
     {
         smc_diffs = pars$smc - avg_smc         
         new_smc  = avg_smc   + rnorm(1, 0, violence)
         new_smcs = new_smc + smc_diffs    
         chosen_move = T
     }
     if(no_moves>1)
     {
       for(move in 2:no_moves)
       {
         if(rand< move/no_moves)
         {
            #g_dist      = mean(pars$cld[,(move-1)])
            #new_dst     = abs(g_dist + rnorm(1, 0, violence))
            #new_dst     = rep(new_dst, noco)
            #pars$cld[,move-1] = abs(new_dst + rnorm(noco, 0, col_sp_var))  
            #chosen_move = T
    
            cld_diffs = pars$cld[,(move-1)] - avg_cld[(move-1)]
            new_dst   = (avg_cld[move-1] + rnorm(1, 0, violence))
            new_dsts[,(move-1)]  = abs(new_dst + cld_diffs)  
            break()    
         }  
       }
     }
     #Code to reject stupid moves.
     if(objects$flags$DEBUG>0.1 & move_attempts == 200) {
       cat("Warning - seemingly difficult to find a non-stupid move in c_clust_mean2.\n"); if(objects$flags$DEBUG>2 & move_attempts==200) {browser()}
       violence = violence/5
     }
     if(move_attempts>600) {
       cat("Given up - returning unchanged values after 600 attempts.\n"); if(objects$flags$DEBUG>2.5 | objects$flags$DEBUG==1.678) {browser()}
       return(pars)
     }
     new_dsts  = mypmax(inmat = new_dsts, objects$flags$min_extra_cld)
     reject = check_clm(objects=objects, smcs=new_smcs, dsts=new_dsts, move="c_clust_mean2", cur=F)
     move_attempts = move_attempts+1;
   }
  #smcs_clds = rev_hk3(smcs=new_smcs, clds=new_dsts, nocl=pars$nocl, noco=pars$noco, mom_type="mean", vals=grid_vals, flags=objects$flags)
  #pars$smc = smcs_clds$smcs
  #pars$cld = smcs_clds$clds


   pars$smc = new_smcs
   pars$cld = new_dsts
   display_attempts(DEBUG=objects$flags$DEBUG, move_attempts=move_attempts, func="c_clust_mean2", pars=pars)
   if(combined) check_cols_same(objects=objects, initialise=F, mv="change_mean_2")
   return(pars)
}

#change cluster means - this move just moves one of the cluster CENTRES (so one or two distance may change)
c_clust_mean3=function(objects, pars, violence = 0.001, iter, precision=1e-10)
{
   reject=T; #The purpose of this variable is just to reject various moves which are stupid for various reasons.
   cur_bad       = check_clm(objects=objects, smcs=pars$smc, dsts=pars$cld, move="c_clust_mean3", cur=T)
   rownames_cld  = rownames(pars$cld)
   grid_vals = as.numeric(rownames(objects$dat))
   move_attempts = 0;
   if(0 & iter==13) browser();
   display_attempts(DEBUG=objects$flags$DEBUG, move_attempts=move_attempts, func="c_clust_mean3", pars=pars)
   while(reject)
   {
     rand     = runif(1, 0, 1)
     nocl     = pars$nocl  
     noco     = pars$noco
     no_moves = nocl
     chosen_move=F
     avg_smc = mean(pars$smc)
     smc_diffs = pars$smc - avg_smc
     avg_cld   = colMeans(pars$cld)
     cld_diffs = pars$cld - matrix(rep(avg_cld), nrow=noco, ncol=nocl-1, byrow=T)
  
    #if(pars$nocl  > 2) cld = colMeans(pars$cld[,])
    #if(pars$nocl == 2) cld =  mean(pars$cld[,])
     new_clds = pars$cld
     clm = cumsum(c(avg_smc, avg_cld)) #the class means
  
     for(move in 1:no_moves)
     {
       if(rand< move/no_moves)
       {
          new_clm       = clm
          new_clm[move] = clm[move] +    (rnorm(1, 0, violence))
          new_clm = sort(new_clm, decreasing=F)
         #new_clm[move] = clm[move] + abs(rnorm(1, 0, violence))
          new_clm_allc     = matrix(new_clm, nrow = noco, ncol=nocl, byrow=T)
          new_clm_allc[,1] = new_clm_allc[,1] + smc_diffs
          if(nocl>1)
          {
            for(cl in 2:nocl)
              new_clm_allc[,cl] = new_clm_allc[,cl] + cld_diffs[,cl-1]
          } else
          {
          }
          for(col in 1:noco)
            new_clm_allc[col,] = sort(new_clm_allc[col,], decreasing=F)
          break()
       }
     }
     if(objects$flags$DEBUG>0.1 & move_attempts == 200) {
       cat("Warning - seemingly difficult to find a non-stupid move in c_clust_mean3.\n"); if(objects$flags$DEBUG>5 & move_attempts==200) {browser()}
       violence = violence/5
     }
     if(move_attempts>600) {
       cat("Given up - returning unchanged values after 600 attempts.\n"); if(objects$flags$DEBUG>1.5 & move_attempts==200) {browser()}
       return(pars)
     }
     if(nocl==1) n_dsts = matrix(-1, nrow=noco, ncol=0)
     if(nocl==2) n_dsts = t(t(apply(new_clm_allc, 1, diff))); 
     if(nocl> 2) n_dsts =   t(apply(new_clm_allc, 1, diff)) ; 
     dimnames(n_dsts)       = dimnames(pars$cld)
     rownames(new_clm_allc) = rownames(pars$clv) #Nothing to do with variances, just want the dimnames.

     o_reject = check_clm(objects=objects, smcs=new_clm_allc[,1], dsts=n_dsts       , move="c_clust_mean3", cur=F, average=F)
     n_reject = check_clm(objects=objects, smcs=NULL, dsts=NULL, in_clm=new_clm_allc, move="c_clust_mean3", cur=F, average=F)

     if(!(o_reject == n_reject) & objects$flags$DEBUG>2) {cat("Problem in change means 3.\n"); browser();}
     reject = o_reject | n_reject
     move_attempts = move_attempts+1;
   }
  #for(coll in 1:noco)
  #  new_clm_allc[coll,] = rev_hk2(mom_type="mean", moments=new_clm_allc[coll,], nocl=nocl, vals=grid_vals, flags=objects$flags)
   new_clds_tmp = objects$npars$cld
   for(col in 1:noco)
     new_clds_tmp[col,] = diff(new_clm_allc[col,])
   new_clds  = mypmax(inmat = new_clds_tmp, objects$flags$min_extra_cld) ##This implements the minimum possible EXTRA distance feature that the program now has
   pars$smc  = new_clm_allc[,1]
   pars$cld  = new_clds
   chosen_move = T
   display_attempts(DEBUG=objects$flags$DEBUG, move_attempts=move_attempts, func="c_clust_mean3", pars=pars)
   if(is.na(range(c(pars$smc, pars$cld))[1])) {cat("Error - Invalid new class means:", range(c(pars$smc, pars$cld))[1], "\n"); browser();}
  #final_check = max(abs(range(t(apply(cbind(pars$smc, pars$cld), 1, cumsum)))))<=(max(abs(grid_vals))+precision)
  #if(objects$flags$DEBUG>1 & !final_check) {cat("Error in ch_mean3. Returning class means that go outside the sensible range.\n"); browser();}
   return(pars)
}


#change COLLECTION SPECIFIC cluster means - this move shifts one collections clusters left or right
c_clust_mean_cspec=function(objects, pars, col_sp_var = 0.001)
{
   check_clm(objects=objects, smcs=pars$smc, dsts=pars$cld, move="c_clust_spec_mean1", cur=T)
   display_attempts(DEBUG=objects$flags$DEBUG, move_attempts=1, func="c_clust_mean_cspec", pars=pars)
   rand        = runif(1, 0, 1)
   no_moves    = pars$noco
   npars       = pars
   chosen_move = F
   for(move in 1:no_moves)
   {
     if(rand< move/no_moves)
     {
        shift              = rnorm(1, 0, col_sp_var)
        npars$smc[move]    = pars$smc[move]        + shift
        npars$cld[(move),] = abs(pars$cld[(move),] + shift)
        break()
     }
   }
   npars$cld  = mypmax(inmat = npars$cld, objects$flags$min_extra_cld)
   reject    = check_clm(objects=objects, smcs=npars$smc, dsts=npars$cld, move="c_clust_mean_cspec", cur=F)
   if(!reject) pars = npars
   display_attempts(DEBUG=objects$flags$DEBUG, move_attempts=1, func="c_clust_mean_cspec", pars=pars)
   return(pars)
}


#change COLLECTION SPECIFIC cluster means - this move shifts one cluster in one collection left or right
c_clust_mean_cspec2=function(objects, pars, col_sp_var = 0.001)
{
   nocl = objects$opars$nocl
   check_clm(objects=objects, smcs=pars$smc, dsts=pars$cld, move="c_clust_spec_mean1", cur=T)
   display_attempts(DEBUG=objects$flags$DEBUG, move_attempts=1, func="c_clust_mean_cspec2", pars=pars)
   rand = runif(1, 0, 1)
   no_moves = pars$noco*pars$nocl
   npars = pars
   chosen_move=F
   for(move in 1:no_moves)
   {
     if(rand< move/no_moves)
     {
        col = ceiling(move/pars$nocl)
        cl  = move - ((col-1)*nocl)
        if(cl==1) {
          shift = rnorm(1, 0, col_sp_var)
          npars$smc[col] = pars$smc[col] + shift
        } else    {
          shift                   = runif(1, -col_sp_var, col_sp_var)
          npars$cld[(col),(cl-1)]  = abs(pars$cld[(col),(cl-1)] + shift)
        }
        break()
     }
   }
   npars$cld  = mypmax(inmat = npars$cld, objects$flags$min_extra_cld)
   reject    = check_clm(objects=objects, smcs=npars$smc, dsts=npars$cld, move="c_clust_mean_cspec2", cur=F)
   if(!reject) pars = npars
   display_attempts(DEBUG=objects$flags$DEBUG, move_attempts=1, func="c_clust_mean_cspec2", pars=pars)
   return(pars)
}




#change cluster variances
c_betas=function(objects=NULL, pars, violence = 0.001, model="full_model")
{
   ch_beta1 = (model=="full_model" | model=="full_no_hierarchy")
   #check = ch_beta1 | model=="hier_nocl_choice"; if(objects$flags$DEBUG>0.5 & !check) {cat("Error in c_Betas.Shoudn't be changing betas for this model.\n"); browser();}
   check = (model!="simple")
   if(!is.null(objects)) {
     if(objects$flags$DEBUG>0.5 & !check) {cat("Error in c_Betas.Shoudn't be changing betas for this model.\n"); browser();}
   } else if(!check) {cat("Error in c_Betas.Shoudn't be changing betas for this model.\n"); browser();}
   rand = runif(1, 0, 1)
  #if(rand < 0.2 | !ch_beta1) {beta0 = pars$betas[1] + rnorm(1, 0, violence); beta1 = pars$betas[2];}
  #if(rand>= 0.2 &  ch_beta1) {beta1 = pars$betas[2] + rnorm(1, 0, violence); beta0 = pars$betas[1];}
   beta0 = pars$betas[1] + rnorm(1, 0, violence); 
   if(ch_beta1) beta1 = pars$betas[2] + rnorm(1, 0, violence) else beta1 = pars$betas[2];
   pars$betas = c(beta0, beta1)
   return(pars)
}

#I should try to perturb these parameters according to the tightness of the priors and likely range etc.
c_h_pars=function(objects, violence = 0.001) #objects$npriors is the object being altered (as npriors within here)
{                                    
  nocl    = objects$opars$nocl;
  npriors = objects$npriors;
  hp_rand = runif(1, 0, 1)
  no_types = 12
  move_b_points = (0:(no_types-1)/no_types)
  lv = log(violence)/2
  #means
  # - smc
  #  - mean
  if(hp_rand >=move_b_points[1] & hp_rand <move_b_points[2]) {
    mv="smc_mean"
   #npriors$prsmc$mean = npriors$prsmc$mean + rnorm(1, 0, violence)
   #npriors$prsmc$mean = npriors$prsmc$mean * runif(1, 1/10, 10)
    npriors$prsmc$mean = npriors$prsmc$mean * exp(runif(1, -abs(lv), abs(lv)))
  }  
  #  - var
  if(hp_rand >=move_b_points[2] & hp_rand <move_b_points[3]) {
    mv="smc_var"
   #npriors$prsmc$var = abs(npriors$prsmc$var + rnorm(1, 0, violence))
    npriors$prsmc$var = npriors$prsmc$var * exp(runif(1, -abs(lv), abs(lv)))
  }  
  # - cld  
  #  - shape
  if(hp_rand >=move_b_points[3] & hp_rand <move_b_points[4]) {
    mv="cld_shape"
    npriors$prcld$shape = abs(npriors$prcld$shape + rnorm(1, 0, violence))
  }  
  #  - scale
  if(hp_rand >=move_b_points[4] & hp_rand <move_b_points[5]) {
    mv="cld_scale"
    npriors$prcld$scale = abs(npriors$prcld$scale + rnorm(1, 0, violence))
  }  

  #vars
  # - base
  #  - mean
  if(hp_rand >=move_b_points[5] & hp_rand <move_b_points[6]) {
    mv="clv_base_mean"
    npriors$prlclv_base$mean = npriors$prlclv_base$mean + rnorm(1, 0, violence)
  }    
  #  - var
  if(hp_rand >=move_b_points[6] & hp_rand <move_b_points[7]) {
    mv="clv_base_var"
    npriors$prlclv_base$var = abs(npriors$prlclv_base$var + rnorm(1, 0, violence))
  }    
  # - inc
  #  - scale
  if(hp_rand >=move_b_points[8] & hp_rand <1               ) {
    mv="clv_inc_scale"
    npriors$prlclv_inc$scale = abs(npriors$prlclv_inc$scale + rnorm(1, 0, violence))
  }    
  #  - shape
  if(hp_rand >=move_b_points[7] & hp_rand <move_b_points[8]) {
    mv="clv_inc_shape"
    npriors$prlclv_inc$shape = abs(npriors$prlclv_inc$shape + rnorm(1, 0, violence))
  }    
  ##Old style hprior move changers
  if(hp_rand >=move_b_points[8] & hp_rand <move_b_points[9]) {
    mv="c_hpr_clvb"
    objects = c_hpr_clv_base(objects=objects, violence = violence)
    npriors = objects$npriors
  }    
  if(hp_rand >=move_b_points[9] & hp_rand <move_b_points[10]) {
    mv="c_hpr_clvi"
    objects = c_hpr_clv_inc( objects=objects, violence = violence)
    npriors = objects$npriors
  }    
  if(hp_rand >=move_b_points[10] & hp_rand <move_b_points[11]) {
    mv="c_hpr_smc"
    objects = c_hpr_smc(     objects=objects, violence = violence)
    npriors = objects$npriors
  }    
  if(hp_rand >=move_b_points[11] & hp_rand <move_b_points[12]) {
    mv="c_hpr_cld"
    objects = c_hpr_cld(     objects=objects, violence = violence)
    npriors = objects$npriors
  }    
  objects$npriors = npriors;
  change = list(objects, mv)
  names(change) = list("objects", "mv")
  return(change)
}





#change cluster variances
c_clust_vars=function(objects, pars, violence = 0.001, col_sp_var = 0.0001, combined=F)
{
   noco     = objects$opars$noco
   grid_vals = as.numeric(rownames(objects$dat))
  #g_vars   = colMeans(pars$clv)
  #new_var  = abs(g_vars + rnorm(pars$nocl, 0, violence))
  #new_var  = matrix(rep(new_var, (noco)), nrow=noco, byrow=T)
  #if(!combined) pars$clv = abs(new_var + matrix(rnorm((pars$noco*(pars$nocl)), 0, col_sp_var), nrow=noco))

  dimnames_clv = dimnames(pars$clv)
   if(!combined) new_var  = pars$clv + matrix(rnorm((pars$noco*(pars$nocl)), 0, sd=violence+col_sp_var), nrow=noco)
   if( combined) { 
     g_vars   = colMeans(pars$clv)
     new_var  = abs(g_vars + rnorm(pars$nocl, 0, violence))
     new_var  = matrix(rep(new_var, (noco)), nrow=noco, byrow=T)
   }
   dimnames(new_var) = dimnames_clv
   new_vars = new_var
  #for(coll in 1:noco)
  #  new_vars[coll,] = rev_hk2(mom_type="var", moments=new_vars[coll,], nocl=pars$nocl, vals=grid_vals, flags=objects$flags)
  #cat("Check that minimum variances have been properly subtracted.\n"); browser();
   if( combined) pars$clv = new_vars
   return(pars)
}

c_hpr_clv_base=function(objects, violence = 0.001, col_sp_var = 0.0001)
{
  noco = objects$opars$noco
  objects$npriors$hprclv$base$mean = rnorm(    1, objects$npriors$hprclv$base_mean$mean        , sqrt(objects$npriors$hprclv$base_mean$var)   )
  objects$npriors$hprclv$base$var  = rinvgamma(1, scale = objects$npriors$hprclv$base_var$scale, shape = objects$npriors$hprclv$base_var$shape)
  base_classes              = rnorm(noco, objects$npriors$hprclv$base$mean        , sqrt(objects$npriors$hprclv$base$var))

  #This is all non-necessary code for generating variances from the prior in the absence of data - probably a total waste of time!!
  #inc_mean                  = rgamma(1, scale=objects$npriors$hprclv$inc_mean$scale, shape=objects$npriors$hprclv$inc_mean$shape)
  #inc_var                   = rgamma(1, scale=objects$npriors$hprclv$inc_var$scale , shape=objects$npriors$hprclv$inc_var$shape)
  #objects$npriors$hprclv$inc$scale = inc_var /inc_mean
  #objects$npriors$hprclv$inc$shape = inc_mean/objects$npriors$hprclv$inc$scale
  #objects$opars$clv[,1]     = exp(base_classes)
  #increment = rgamma((noco)*(nocl-1), scale=objects$npriors$hprclv$inc$scale , shape=objects$npriors$hprclv$inc$shape)
  #increment = matrix(increment, noco, (nocl-1))
  #increment = t(t(increment)*(1:(nocl-1)))
  #objects$opars$clv[,-c(1)] = exp(base_classes + increment)
  return(objects)
}


c_hpr_clv_inc=function(objects, violence = 0.001, col_sp_var = 0.0001)
{
  mean = rgamma(1, scale = objects$npriors$hprclv$inc_mean$scale, shape = objects$npriors$hprclv$inc_mean$shape)
  var  = rgamma(1, scale = objects$npriors$hprclv$inc_var$scale , shape = objects$npriors$hprclv$inc_var$shape )
  objects$npriors$hprclv$inc$scale = var / mean
  objects$npriors$hprclv$inc$shape = mean/ objects$npriors$hprclv$scale
  return(objects)
}

c_hpr_smc=function(objects, violence = 0.001, col_sp_var = 0.0001)
{
  objects$npriors$prsmc$mean = rnorm(    1, mean  = objects$npriors$hprsmc$mean$mean, sd    = sqrt(objects$npriors$hprsmc$mean$var))
  objects$npriors$prsmc$var  = rinvgamma(1, scale = objects$npriors$hprsmc$var$scale, shape = objects$npriors$hprsmc$var$shape     )
  return(objects)
}

c_hpr_cld=function(objects, violence = 0.001, col_sp_var = 0.0001)
{
  mean = rgamma(1, scale = objects$npriors$hprcld$mean$scale, shape = objects$npriors$hprcld$mean$shape)
  var  = rgamma(1, scale = objects$npriors$hprcld$var$scale , shape = objects$npriors$hprcld$var$shape )
  objects$npriors$hprcld$scale = var / mean
  objects$npriors$hprcld$shape = mean/ objects$npriors$hprcld$scale
  return(objects)
}

# Do I want to do these stochastically or R-B this bit?
c_allele_frequencies=function()
{

}


#Currently there is some small bug/hole in my logic in this function which leaves the sum not quite 1.
raise_tiny_gnfs=function(gnf_lambda, no_inds_vec, precision=1e-3)
{
   noco    = length(no_inds_vec)
   no_inds = sum(no_inds_vec)
   vlow    = which(gnf_lambda < 1/no_inds, arr.ind=F)
   gnf_lambda2        = gnf_lambda
   if(length(vlow>0)) {
     gnf_lambda2[ vlow] = 1/no_inds
    #reduced_num = no_inds_vec - (length(vlow) - sum(gnf[vlow]*no_inds_vec))/noco
    #gnf2[-vlow] = gnf[-vlow]*(reduced_num/no_inds_vec)
    #if(abs(sum(gnf2)-noco)>precision | abs(sum(gnf)-noco)>1e-5) {cat("Warning, gnf not set properly.\n"); browser();}
   }
   for(coll in 1:noco) gnf_lambda2 = gnf_lambda2/sum(gnf_lambda2)
   gnf_lambda = gnf_lambda2
   return(gnf_lambda)
}

# This function maximises the genotype frequency posterior
combined_maxgnf=function(objects, min_1=T, new=T, precision=2e-4, controls_only=T)
{
  dat    = objects$dat
  no_inds_vec = colSums(dat)
  noco   = objects$opars$noco;
  nocl   = objects$opars$nocl
  anocl  = objects$opars$anocl
  #if(new) lpagd  = objects$ninferred$lpagd else lpagd  = objects$oinferred$lpagd
  if(new)  pagd  = objects$ninferred$pagd  else  pagd  = objects$oinferred$pagd
  if(objects$flags$DEBUG>0.5 & (min(pagd)<0 | max(pagd)>1)) {cat("Error, impossible pagd.\n"); browser();}
  #pagd   = exp(lpagd)
  #av_gnf = rep(-1, length=nocl)
  new_lmdgnf = rep(-1, length=nocl)
  nullcounts = rep(-1, length=1)
  null_prop  = objects$opars$null_prop
  case_colls = objects$assoc$case_colls
  caseNames    = names(case_colls)[which(case_colls==1)]
  controlNames = names(case_colls)[which(case_colls==0)]

  #(!) Really you shouldn't just use the controls! You could in principle use the frequencies in the cases and work backwards using the logistic regression!
  rem_cases = controls_only & length(case_colls)>0 & objects$flags$model=="full_model" # This says when estimating population gnf with the full model only use controls.
  if(rem_cases) {
   #This function estimates the frequencies in CONTROLS (although wtccc doesn't have real controls from a modelling perspective...)
    pagd =  pagd[,, controlNames, drop=F]
    dat  = dat[   , controlNames, drop=F]
  }

  for(cl in 1:anocl) {
  #if(cl<= nocl  ) av_gnf[cl]          = sum(pagd[,cl,]*objects$dat[,])/sum(objects$dat)
   if(cl< nocl+1) {
     this_gnf       = sum(pagd[,cl,]*dat)/sum(dat)
     if(objects$flags$DEBUG>0.5 & (this_gnf<0 | this_gnf>1)) {cat("Error, impossible gnf.\n"); browser();}
     new_lmdgnf[cl] = this_gnf  #(Estimated from the controls)
   }
   if(cl== nocl+1) {
     null_c = sum(pagd[,cl,]*dat)
     nullcounts[cl-nocl] = null_c
   }
  }
  checklen = length(new_lmdgnf)==nocl
  if(!checklen) {cat("Warning! In combined_maxgnf Length of lambdas is not equal number of classes!\n"); browser();}
  #gnf = matrix(av_gnf, nrow=nocl, ncol=noco) 
  #dimnames(gnf) = dimnames(objects$opars$gnfp$gnf)
  if(!objects$flags$use_null) sumto1 = sum(new_lmdgnf)- 1                             <precision
  if( objects$flags$use_null) sumto1 = sum(new_lmdgnf)-(1-nullcounts/sum(objects$dat))<precision
  if(!sumto1) {
   cat("Error, genotype frequencies don't sum to 1(", new_lmdgnf, "). (First check)\n", sep=" "); browser();
  }
  if(min_1) new_lmdgnf= raise_tiny_gnfs(gnf_lambda=new_lmdgnf, no_inds_vec=no_inds_vec) #really this is gnf_controls, not gnf_lambda
  if(objects$flags$DEBUG>1.1 & min(new_lmdgnf)<0.5/sum(objects$dat)) {
   cat("Warning! Some Allele Frequencies very low. Should no longer be possible.\n"); 
   browser();
  }   

  non_null_freq = sum(new_lmdgnf)
  #if( objects$flags$use_null) gnf = t(t(gnf)/non_null_freqs*(1-null_prop)) #Normalising genotype frequencies so that the null_frequency is maintained at null_prop (that's what Jonathan wants)
  if( objects$flags$use_null) new_lmdgnf= new_lmdgnf/non_null_freq*(1-null_prop) #Normalising genotype frequencies so that the null_frequency is maintained at null_prop (that's what Jonathan wants)
  if(0 & objects$flags$model=="full_model") browser();
  #if(!objects$flags$use_null) sumto1 = sum(abs(colSums(gnf)- 1                             )<precision) == ncol(gnf)
  #if( objects$flags$use_null) sumto1 = sum(abs(colSums(gnf)-(1-null_prop                  ))<precision) == ncol(gnf)
  #if(!sumto1) {
  #  cat("Error, genotype frequencies don't sum to 1(", colSums(gnf), "). (Second check)\n", sep=" "); browser();
  #}
  #for(coll in 1:noco) gnf[,coll] = gnf[,coll]/sum(gnf[,coll])
  #objects$npars$gnfp$gnf = gnf
  objects$npars$gnfp$gnf_controls = new_lmdgnf
  objects$npars$gnfp$gnf_lambda   = make_pop_from_control_only(objects=objects, control_freqs=objects$npars$gnfp$gnf_controls, new=T) #This doesn't use case frequencies
  objects$npars$gnfp$gnf_cases    = make_case_freqs(objects=objects   , pop_freqs =objects$npars$gnfp$gnf_lambda  , new=T) #This USES population frequencies!
  objects$npars$model_pdisease    = get_model_pdisease(objects=objects, new=T, from_controls=T)
  check_control_freq              = make_control_freqs(objects=objects, pop_freqs =objects$npars$gnfp$gnf_lambda  , new=T)
  check_gnfcs  = sum(abs(check_control_freq-new_lmdgnf))<(precision/20)
  if(objects$flags$DEBUG>0.5 & !check_gnfcs)  {cat("In combined_max_gnf. conversion of frequencies may be wrong.\n"); browser()}

  if(0 & objects$flags$model %in% c("full_model", "full_no_hierarchy")) {
   cat("DEBUGGING CODE: the proposed three gnfs are (on iter ", objects$flags$iter, "):\n", sep="")
   cat("gnf_controls: "); print(objects$npars$gnfp$gnf_controls); cat("gnf_lambda  : "); print(objects$npars$gnfp$gnf_lambda  ); cat("gnf_cases   : "); print(objects$npars$gnfp$gnf_cases)
  #if(objects$flags$iter>150) browser();
  }
  #debug(calc_intens_lkld)
  return(objects)
}

# change_gnf(objects=objects, gnf_sd=0.02)
change_gnf=function(objects, gnf_sd=0.02)
{
  pop_freqs  = objects$opars$gnfp$gnf_lambda
  sum        = sum(pop_freqs)
  cl_rand    = runif(1, 0, 1)
  boundaries = ((1:length(pop_freqs))-1)/length(pop_freqs)
  change_cl  = which(boundaries>cl_rand)
  pop_freqs[change_cl] = abs(pop_freqs[change_cl] + rnorm(1, mean=0, sd=gnf_sd))
  pop_freqs  = normalise(pop_freqs, sum=sum)
  objects$npars$gnfp$gnf_lambda   = pop_freqs
  objects$npars$gnfp$gnf_controls = make_control_freqs(objects=objects, pop_freqs =objects$npars$gnfp$gnf_lambda  , new=T) #This USES population frequencies!
  objects$npars$gnfp$gnf_cases    = make_case_freqs(objects=objects   , pop_freqs =objects$npars$gnfp$gnf_lambda  , new=T) #This USES population frequencies!
  objects$npars$model_pdisease    = get_model_pdisease(objects=objects, new=T, from_controls=T)
  return(objects)
}

#This function changes the hyper parameters (ie. the lambdas) for the allele frequencies
#It may start doing this at the same time as setting the allele frequencies
change_gnf_hpars=function(objects, mid_move=F, maximise=F, violence = 0.03^2, precision=1e-10)
{
  nocl= objects$opars$nocl
  if(!maximise) {
    gnf_a_m = objects$opars$gnfp$gnf_a_m
    gnf_a_v = objects$opars$gnfp$gnf_a_v
    gnf_hp_shape1 = gnf_a_m*(gnf_a_m*(1-gnf_a_m)/gnf_a_v -1); # mean = a/(a+b), var = (a*b)/((a+b)^2*(a+b+1))
    gnf_hp_shape2 = (gnf_hp_shape1/gnf_a_m)-gnf_hp_shape1; #'alpha_var' in the model - the variance of the parameter 'gnf_apar' (alpha in the model), describes gnf_ws (w in the model)3
    gnf_theta   = objects$opars$gnfp$theta; #'theta' in the model - control how close to HWE we are
    #(alpha in the model) This is a draw from the prior on the distribution of the tightness of the dirichlet in the gnf model:
    new_gnf_apar    = rbeta(1, shape1=gnf_hp_shape1, shape2=gnf_hp_shape2)
  } else        {   
    if(nocl%%2==1) no_alleles = (objects$opars$nocl+1)/2
    if(nocl%%2==0) no_alleles = (objects$opars$nocl+2)/2
     new_gnf_apar = (objects$opars$gnfp$gnf_lambda[1])^(1/no_alleles)
    if(objects$flags$DEBUG>2.5 & objects$flags$iter==1 & objects$flags$verbose) cat("Maximising alpha not implemented robustly \n");
  }
  objects$npars$gnfp$gnf_ws      = make_ws_from_alpha(gnf_apar=new_gnf_apar, nocl=nocl, gnf_theta=objects$opars$gnfp$gnf_theta)
 # cat("CHECK: Look at gnf_ws, see if they approximate gnf_lambda, they should be quite close!\n"); browser();
 # The make_ws_from_alpha function has this hacky 'reverse' line in it that could probably be recoded better
  check = abs(sum(objects$npars$gnfp$gnf_ws)-1)<precision
  if(!check) {cat("Warning! w's don't sum to 1.\n"); browser();}
  if((abs(new_gnf_apar)<precision | abs(1-new_gnf_apar)<precision) & (objects$opars$nocl>1 | objects$flags$DEBUG>2.5)) {
    if(objects$opars$nocl>1  & !maximise) cat("Warning! exceedingly unlikely (and problematic) alpha chosen.\n"); browser();
    if(objects$opars$nocl==1 |  maximise) cat("Warning! Program may not be robust to fixed alles? (ok if using null class)\n"); browser();
  }
  objects$npars$gnfp$gnf_apar = new_gnf_apar
  return(objects)
}



#Estimating cluster VARIANCES using hard calls.
maxL_variances=function(objects, new=T, use_hcalls=T, combined=F, precision=1E-10)
{
  noco = objects$opars$noco
  nocl = objects$opars$nocl
 #if(new) lpagd = objects$ninferred$lpagd else lpagd = objects$oinferred$lpagd
  if(new)  pagd = objects$ninferred$pagd  else  pagd = objects$oinferred$pagd
  #This calls the GRID VALUES. 
  wdat         = objects$flags$wdat
  grid_hcalls = apply(pagd, c(1,3), which.max) 
  vals         = as.numeric(rownames(objects$dat))
  dimnames_clv = dimnames(objects$opars$clv)
  if(use_hcalls)
  {
    vars_est = objects$npars$clv
    for(coll in 1:noco)
    {
      for(cl in 1:nocl)
      {
       this_cl_indices   = which(grid_hcalls[,coll]==cl)
       subset_dat        = objects$dat[this_cl_indices,coll]
       names(subset_dat) = names(objects$dat[,coll])[this_cl_indices]
       moments           = calc_dat_moments(data=subset_dat, in_clv=objects$npars$clv[coll,cl])
       if( is.null(moments$var)) return(objects)
       if(!is.null(moments$var)) vars_est[coll,cl] = reverse_hack(vals=vals, cl=cl, coll=coll, flags=objects$flags, moments=moments, wanted_moment="var")
         total_sd     = sqrt(moments$var); extra_sd = sqrt(vars_est[coll,cl]); hds = total_sd-extra_sd;
         official_min = get_hack_diff_sd(wdat=wdat, add_var=objects$flags$hack_add_var)
         if(objects$flags$DEBUG>0.1 & !abs(hds-official_min)<precision & vars_est[coll,cl]>(objects$flags$min_var+1e-20))
         {cat("In maxL_variances. Something wrong with implmentation of min-variance.\n");   browser();}
       if(vars_est[coll,cl]<0) {cat("In maxL_variances. Last returned var is negative.\n"); browser();}
       if(objects$flags$DEBUG>2.5 & objects$flags$verbose & vars_est[coll,cl]<=(objects$flags$min_var+1e-20)) {cat("In maxL_variances. Suggested variance below minimum allowed.\n");}
       }
    }
  } else
  {
    sce      = soft_clmoment_estimate(objects=objects, mom_type="var")
    problem  = sce$problem
    objects$flags$no_null_moves = objects$flags$no_null_moves + 1
    if(problem) 
      return(objects) #That is, if the model fit is such that this method has problem DON'T CHANGE ANYTHING
    vars_est = sce$mom_est
   #cat("Check implementation of reverse_hack for soft_calls.\n"); browser();
  }
  if(sum(vars_est<0)>0) {cat("In maxL_variances. Error, cannot have negative variances.\n"); browser();}

  if(!combined) {
    objects$npars$clv = vars_est
  } else        {
    #if(objects$flags$DEBUG>1.49) {cat("In MaxL_variances. Why am I taking the average of these variance estimates?\n"); browser();}
    #This functionality is so that I can maximise the variances in the classes when NOT using the hierarchical model!
    # (!) It would be (much) better to calculate the variances from the combined data than to take the means here!
    av_clv            = colMeans(vars_est)
    objects$npars$clv = matrix(rep(av_clv, noco), nrow=noco, byrow=T)
  }
 #if(objects$flags$DEBUG>1.5 & objects$flags$verbose & min(vars_est)<=(min_var+1e-20))
 #  cat("In maxL_variances. Suggested essentially variance below what the model will allow.\n");
  if(objects$flags$DEBUG>0.1) check_clv(clv=objects$npars$clv, min_var=1E-50, hkclv=NULL)
  dimnames(objects$npars$clv) = dimnames_clv
  if(combined) check_cols_same(objects=objects, initialise=F, mv="actually_in_maxL_vars")
  return(objects)
}




#Estimating cluster VARIANCES using hard calls.
maxL_means=function(objects, use_hcalls=F, combined=F, controls_only=T, hcalls_thresh=0.4)
{
  hcall_rand    = runif(1, 0, 1)
  if(hcall_rand<hcalls_thresh) use_hcalls = T; ##The idea is to get a greater variety of move types (as there are pros and cons to hard calls)
  noco          = objects$opars$noco
  nocl          = objects$opars$nocl
 #lpagd         = objects$ninferred$lpagd
   pagd         = objects$ninferred$pagd
  cur_clm       = make_clm(smcs=objects$opars$smc, clds=objects$opars$cld, nocl=objects$opars$nocl, noco=noco)
  vals          = as.numeric(rownames(objects$dat))

  if(!is.matrix(cur_clm)) means_est = matrix(cur_clm, nrow=noco)
  if( is.matrix(cur_clm)) means_est = cur_clm
  if(nrow(means_est)!=objects$opars$noco){cat("In maxL_means. Dimensions of means_est are wrong.\n"); browserdump();}

  case_colls   = objects$assoc$case_colls
  caseNames    = names(case_colls)[which(case_colls==1)]
  controlNames = names(case_colls)[which(case_colls==0)]
  rem_cases    = controls_only & length(case_colls)>0 & objects$flags$model=="full_model" & 0 # This is SET TO ZERO. We don't expect means to change based on DISEASE STATUS
  use_colls    = colnames(objects$dat)
  if(rem_cases) {
    pagd      =  pagd[,,  controlNames, drop=F]
    use_colls = use_colls[controlNames]
  }
  if(use_hcalls) #This will or will not occur stochastically (see top of function)
  {
    grid_hcalls = apply( pagd, c(1,3), which.max)   #This calls the GRID VALUES. 
    if(0) { #This is a potentially faster way of getting the hard calls.
      grid_hcalls = matrix(NA, nrow=dim(pagd)[1], ncol=dim(pagd)[3]); 
      for(coll in 1:dim(pagd)[3]) 
        grid_hcalls[,coll] = make_hcalls(calls_mat=pagd[,,coll], nocl=dim(pagd)[2], call_thresh=0)
    }
   #empty_clust=numeric(0)
    for(collName in use_colls) #coll indexes objects which contain info on all collections (case or control)
    {
      for(cl in 1:nocl)
      {
        this_cl_indices        = which(grid_hcalls[,collName]==cl)
        subset_dat             = objects$dat[this_cl_indices, collName]
        names(subset_dat)      = rownames(objects$dat)[this_cl_indices]
        moments                = calc_dat_moments(data=subset_dat, in_clv=objects$opars$clv)
        if(moments$empty_clust) moments = list("mean" = objects$opars$hkclm[collName,cl], "var" = objects$opars$hkclv[collName,cl], "empty_clust"=T)
        means_est[collName,cl]   = moments$mean
       #The commented out line below is now done elsewhere so that the means can be sorted first (because of the above line)
       #means_est[collName,cl] = reverse_hack(vals=vals, cl=cl, flags=objects$flags, moments=moments, wanted_moment="mean")
       #if(moments$empty_clust) empty_clust=c(empty_clust, cl)
      }
     means_est[collName,] = sort(means_est[collName,], decreasing=F)
     means_est[collName,] = rev_hk2(mom_type="mean", moments=means_est[collName,,drop=F], nocl=nocl, vals=vals, flags=objects$flags)
     #if(sum(means_est==0)>0){
     #  if(objects$flags$DEBUG>1.5) cat("Model fit is too poor to use maxL_means until I upgrade to soft_calls.NO CHANGE made.\n")
     #  objects$flags$no_null_moves = objects$flags$no_null_moves+1
     #  return(objects)
     #}
    }
    #cat("empty_clust = ", empty_clust, "\n"); browser()
    #means_est = process_means_est(means_est=means_est, noco=noco, nocl=nocl, empty_clust=empty_clust)
  } else 
  {
    sce = soft_clmoment_estimate(objects=objects, mom_type="mean", rem_cases=rem_cases)
    if( sce$problem) {objects$flags$no_null_moves = objects$flags$no_null_moves + 1; return(objects) }
    if(!sce$problem) means_est = sce$mom_est
  }
  rownames(means_est) = rownames(objects$opars$clv)
  decomp            = make_smcs_clds(means_est, nocl) # decompose clm in smc and cld.
  if(!combined)
    smcs   = decomp$smcs
    clds   = mypmax(decomp$clds, objects$flags$min_extra_cld)
  if( combined) {
    smcs   = rep(mean(decomp$smcs), noco)
    av_cld = colMeans(decomp$clds)
    clds   = mypmax(matrix(rep(av_cld, noco), nrow=noco, byrow=T), objects$flags$min_extra_cld)
  }
  dimnames(clds) = dimnames(objects$opars$cld)
  reject1 = check_clm(objects=objects, smcs=smcs, dsts=clds, in_clm=NULL, move="maxL_means", cur=F)
  if(!reject1) {
    objects$npars$smc = smcs
    objects$npars$cld = clds
  }
  if(sum(!(objects$npars$cld> 0))>0) {cat("In maxL_means. Error, cannot have negative distances between clusters.\n"); browserdump();}  
  if(sum(!(objects$npars$clv>=0))>0) {cat("In maxL_means. Error, cannot have negative variances of clusters.\n"     ); browserdump();}
  #reject2 = check_clm(objects=objects, smcs=objects$npars$smc, dsts=objects$npars$cld, move="maxL_means", cur=F)
  #if(reject2 & objects$flags$DEBUG>1){ 
  #  cat("In maxL_means. Proposed means lie outside sensible range.\n"); 
  #  cat("This is the SECOND check in maxL_means. Seeing this message implies a bug in maxL_means.\n"); 
  #  browser();
  #}
  if(use_hcalls & nocl==3 & objects$flags$DEBUG>3) {cat("Check that hard calls are working well.\n"); browser();}
  return(objects)
}

#betas = objects$opars$betas
#nbetas = maximise_beta(objects=objects, lower0=-3, upper0=3, lower1=-3, upper1=3, no_to_try=35)
#This function is WAY TOO SLOW to be used as part of the main routine at present.
debug_maximise_beta=function(objects, lower0, upper0, lower1, upper1, no_to_try=20, model="full_model")
{
  beta0s = 0:(no_to_try)/no_to_try*(upper0-lower0) + lower0
  beta1s = 0:(no_to_try)/no_to_try*(upper1-lower1) + lower1
  blks   = matrix(NA, nrow=length(beta0s), ncol=length(beta1s))
  for(b0i in 1:length(beta0s))
  {
    for(b1i in 1:length(beta1s))
    {
      this_beta_lk   = calc_phen_g_gen(objects, direct_betas = c(beta0s[b0i], beta1s[b1i]))$assoc$nlkld
      blks[b0i, b1i] = this_beta_lk
    }
  }
  max_l        = max(blks) # image(blks)
  best_indices = which(blks==max_l, arr.ind=T)
  best_betas   = c(beta0s[best_indices[1]], beta1s[best_indices[2]])
  names(best_betas) = c("beta0", "beta1")
  browser();
  return(best_betas)
  # objects$npars$betas = best_betas #function needs to be better tested before used like this?
  # return(objects)
}

maximise_beta=function(objects, glm_warn=1, model="full_model", precision=1e-10)
{
  in_warn = getOption("warn")
  check = (model!="simple")
  if(objects$flags$DEBUG>0.5 & !check) {cat("Error in c_Betas.Shoudn't be changing betas for this model.\n"); browser();}

  nocl = objects$opars$nocl
  case_colls= objects$assoc$case_colls
  if(sum(case_colls==1)>0) {
    counts    = objects$dat
    grid_vals = (as.numeric(rownames(counts)))
    no_gpts   = nrow(counts)
    callsm    = make_grid_calls(objects=objects, new=F)
    response  = rep(NA, length=(ncol(callsm)*nrow(callsm)))
    names(response) = rep(colnames(callsm), times=rep(nrow(callsm), ncol(callsm)))
    for(collName in colnames(callsm)) {
      response[which(names(response)==collName)] = rep(case_colls[collName], nrow(callsm))
    }
    variation = T
    callsmins = apply(callsm, 2, min)
    callsmaxs = apply(callsm, 2, max)
    betas = objects$opars$betas
    if(sum(callsmins==callsmaxs)>0) {
      return(betas)
    } else {
      calls     = as.vector(callsm)
      weights   = as.vector(counts)
      if(objects$flags$DEBUG<1.72) options(warn=glm_warn)
      if(model=="full_model" | model=="full_no_hierarchy")
      {
        glm          = glm(response~calls, weights=weights, family=binomial)
        options(warn=in_warn)
        glmb0        = glm$coefficients[1]
        glmb1        = glm$coefficients[2]
        # Sometimes glm can't find a single finite maximum. In this case 
        # it can wander off to infinity. Here I've decided on NO CHANGE for this move.
        if( sum(abs(glmb0), abs(glmb1))>1e4 | is.na(glmb0+glmb1)) {return(objects$opars$betas)}
        #glm_llklhd  = -glm$deviance/2
        betas        = c(glmb0, glmb1)
      } else {
        if(model=="hier_nocl_choice" | model=="no_assoc") {
          no_inds     = sum(counts)
          no_controls = sum(counts[,which(case_colls==0)])
          no_cases    = sum(counts[,which(case_colls==1)])
          p_case_hat  = no_cases/no_inds
          beta0_hat   = log(p_case_hat/(1-p_case_hat))
          betas = c(beta0_hat, betas[2])
          if(!(abs(betas[2])<precision)) {cat("Error. In maximise betas. Beta1 Should be 0 for this model\n"); browser();}
        } else {
          if(objects$flags$DEBUG>0.1) {cat("Error - in maximise betas - but have inappropriate model.\n"); browser()}
          return(objects$opars$betas)
        }
      }
      #if(nocl>1) if(is.na(range(betas)[1])) {cat("In maximise_beta. NA returned for beta1.\n"); browser();}
      if(nocl==1) betas[2] = objects$opars$betas[2]; #(With 1 class the additive parameter makes no sense)
      if(is.na(range(betas)[1])) betas[2] = objects$opars$betas[2];
      names(betas) = c("beta0", "beta1")
    }
  } else {
    betas = objects$opars$betas
  }
 #if(objects$flags$model=="full_model") {cat("Why are these large |Beta1|'s being suggested?\n"); cat("Why are they being accepted?\n"); browser();}
  options(warn=in_warn)
  return(betas)
}



# Unused function as it turns out that the object I wanted would already exist (so it just returns that)
make_soft_grid_calls=function(objects, new)
{
 #lpagd = make_lpagd(ob=objects, new=new)
 #if(new) lpagd = objects$ninferred$lpagd else lpagd = objects$oinferred$lpagd
  if(new)  pagd = objects$ninferred$pagd  else  pagd = objects$oinferred$pagd
  #pmode_inds: Posterior mode number of individuals in each class (done for each collection) (gnf*no_inds)
  #pmode_inds  = objects$opars$gnfp$gnf
  #for(coll in 1:noco)
  #  for(cl in 1:nocl)
  #    pmode_inds[coll,cl] = exp(pagd[,cl,coll])*objects$dat[,coll] #so this does all grid_values, but class by class

  #h_calls = (apply(lpagd, c(1,3), which.max) )
  # soft_calls: matrix(nrow = no_grid_vals, ncol=nocl) #holds the posterior probability of that class for that grid_val
  # That is lpagd!
 #return(soft_calls)
  return(pagd)
}

#This function deals with any distances equal to zero. Not sure why now.
process_means_est=function(means_est, noco, nocl, empty_clust)
{
  if(length(empty_clust)>0) {
    problem_inds = which(means_est==0, arr.ind=T)
    for(cl in 1:nocl)
    {
      these_probs = which(problem_inds[,2]==cl)
      if(length(these_probs)>0)
        means_est[these_probs,cl] = mean(means_est[-these_probs,cl]);
    }
  }
  for(coll in 1:noco) {
    means_est[coll,] = sort(means_est[coll,], decreasing=F)
  }
  return(means_est)
}



