\name{getQCstatSummaries}
\Rdversion{1.1}
\alias{getQCstatSummaries}
\alias{makeQCstats}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Functions to produce QC output after calls have been generated and written to standard locations
}
\description{
getQCstatSummaries generates various summaries of quality, for each individual (averaged over CNVs) and for CNVs.
makeQCstats is a very simple wrapper for getQCstatSummaries which writes the output to a standard file-location (it uses the same arguments but also takes in a filename argument: all_QCs_fn
}
\usage{
getQCstatSummaries(merge = T, ldf = T, calls_fns = NULL, csmry_fns = NULL, joined_dir = NULL, sampleNames = get_sample_names(), collections = names(sampleNames), numCNVs = NULL, no_preamble_cols = 4, call_thresh1 = 0.95, call_thresh2 = 0.9, maxCNV = NULL, namedCNVs = NULL, fullStatInds = NULL, statTypes = c("posterior", "likelihood"), DEBUG = 1)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{merge}{ 
  Do you want to get QC for merged (merge=T) or unmerged (merge=F) calls?
}
  \item{ldf}{
  Do you want to get QC for ldf-based (ldf=T) or none-ldf based (ldf=F) calls?
}
  \item{calls_fns}{
  Defaults to NULL, but can supply the location of the calls-files
}
  \item{csmry_fns}{
  Defaults to NULL, but can supply the location of the calls summary file
}
  \item{joined_dir}{
  Defaults to NULL, but can supply the directory where to find the various calls files
}
  \item{sampleNames}{
  Automatically found from the standard output files if not spplied. List of vectors of sample names
}
  \item{collections}{
  Generated from (the names of) sampleNames, recommend that this convention is followed
}
  \item{no_preamble_cols}{
  Defaults to 4, but in case the file format changes this can be specified
}
  \item{call_thresh1}{
  Not yet implemented - but in case thresholded call-rates are calculated this can be used to supply a threshold
}
  \item{call_thresh2}{
  Not yet implemented - but in case *multiple* thresholded call-rates are calculated this can be used to supply a second threshold
}
  \item{maxCNV}{
  If some quick indication of individual qc is required can speficy to average over just the first 'maxCNV' CNVs
}
  \item{namedCNVs}{
  If QC stats averaged over a specific set of CNVs would be useful these can be supplied by name here
}
  \item{fullStatInds}{
  If there are specific individuals for which QC is required then a list of names can be supplied here (see makeListOfInds for a default set)
}
  \item{statTypes}{
  Currently not fully implemented. The idea is to provide flexibility in what stats are calculated. Only default setting (likelihood - posterior) currently works.
}
  \item{DEBUG}{
  Mainly used through it's effect on lower level functions - primarily specifies how trivial a warning-sign is required to pause execution.
}
}
\details{
%%  ~~ If necessary, more details than the description above ~~
}
\value{
Function returns a list of QC summaries, including:             
\item{totalPosteriorPoly}{The sum of the posterior values for each individual across CNVs (split by collection)}
\item{meanPosteriorPoly}{The mean of the posterior values for each individual across CNVs (split by collection)}
\item{totalLikelihoodPoly}{The sum of the likelihood values for each individual across CNVs (split by collection)}
\item{meanLikelihoodPoly}{The mean of the likelihood values for each individual across CNVs (split by collection)}

\item{fullStatsDat}{All QC metrics at each CNV for the listed input individuals}
\item{nocls}{Names vector giving the number of classes inferred at each CNV}
\item{cnvStats}{Matrix giving vavrious QC scores for each CNV, now also broken down by collection}
}
\references{
%% ~put references to the literature/web site here ~
}
\author{
  Niall Cardin
}
\note{
%%  ~~further notes~~
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
  process_calls(), calc_call_rates()
}
\examples{
  cat("  Currently not directly executable examples!\n")
  cat("  However a standard run might involve running this function specifying only merge and ldf.\n")
  cat("  Of course project_root, write_tag etc. would need to be specified to find the calls etc.\n")
}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line
